;
;     UnixWare 2.1 boot code                Part of the MATTsoft Boot Manager
;       - disasm by mhi -                     http://penguin.cz/~mhi/mbtmgr/
;

; This code is from first sector of UnixWare 2.1 partition. It should load
; second part of UnixWare loader from next sectors. 

; WARNING: It is really ugly code. It depends on SPECIFIC UNDOCUMENTED mbr code.

data_8e		equ	7DB0h			;*
data_9e		equ	7DB2h			;*
sectors		equ	7DB4h			;*
sechead		equ	7DB6h			;*
heads		equ	7DB8h			;*

;===========================================================================
boot		segment	byte public use16
		assume cs:boot,ds:boot
		org 7c00h			; loaded at 0:0x7c00

		;-[boot start]-----------------
		jmp short start
		nop
		dd 	0			; align ?!?

start:		;-[real start]-----------------
		mov	ax, cs
		mov	bx, ds			; save old ds to bx
		mov	ds, ax
		mov	es, ax
		mov	ss, ax
		mov	esp, 9274h
		sti				; Enable interrupts
		shl	ebx, 4			; ebx = ebx*16
		add	ebx, esi		; ebx = linear addr of ds:si
		mov	ds:[7c00h], ebx		; == mbr's ds:si

		;-[get disk geom]--------------
		mov	ah, 8			; get_info function
		mov	dl, 80h			; first hdd
		int	13h			; do it, call bios
		jnc	short cont0		; if no error, continue
		mov	esi, offset err1
		jmp	halt

		dw 	0			; fill

cont0:		;-[continue, disk get info ok]-
		xor	ax, ax			; Zero register
		mov	al, cl			; al = cl, sector
		and	al, 3Fh			; mask sector
		shr	cl, 6			; remove low 6 bits (cyls)
		xchg	ch, cl			; now: cx = cylinders
		mov	ds:[sectors], ax	; save sectors
		inc	dh			; heads + 1
		mov	ds:[heads], dh		; save head count
		mul	dh			; sectors * heads
		mov	ds:[sechead], ax	; store for 'diskread'

		;-[look for active partition]--
		mov	esi, dword ptr ds:[7c00]; mbr's ds:si
		xor	ebx, ebx		; ebx = 0
		mov	eax, 7beh		; 
		mov	ecx, 4			; we have four partitions
		;-[scan partition table]-------
part_loop:	cmp	[eax], 80h		; is it active partition?
		jne	part0			; no...
		mov	ebx,eax			; yes, store ptr to ebx
part0:		cmp	esi, eax		; is eax == esi?
		jne	short nextpart		; no, get next partition
		mov	ebx, esi		; ebx = esi
		jmp	short cont1		;
nextpart:	add	eax,10h			; next partition
		loop	part_loop		; until we finish ptable
		;-[end of loop]-----------------

		xor	edx,edx			; edx = 0
		mov	[7c00],edx		; null previously used var.
		test	ebx,ebx			; found active partition?
		jne	cont1			; yes, continue. else error
		mov	esi, err0		; error message
		jmp	short halt		; display & halt

cont1:		;-[read boot code]-------------
		mov	eax, dword ptr [ebx+8]	;
		mov	ds:[data_7], eax	;
		inc	eax			;
		mov	ds:[data_5], eax	;
		call	diskread		; read sector from disk
		xor	eax, eax		; Zero register
		mov	eax, ds:[data_7]	;
		push	eax			;
		mov	ax, ds:[data_9e]	;
		push	eax			;
		mov	ax, ds:[sectors]	;
		push	eax			;
		mov	ax, ds:[sechead]	;
		push	eax			;
		mov	eax, 2000h		;
		push	eax			;
		add	ax, word ptr ds:data_9e	;
		call	eax			; Boot!

;==========================================================================
; halt processor and display message

halt:		;-[stop processor]-------------
		call printstr			; print erro message is [esi]
halt0:		sti				; Enable interrupts
		hlt				; Halt processor
		jmp short halt0

;============================================================================
; print subroutine

print:		mov	bl, 1			; Default attribute
print_loop:	cld				; Clear direction
		lodsb				; load next char
		or	al, al			; end of string?
		jz	short print_end		; yes, return
		mov	ah, 0Eh			; function write char
		int	10h			; write it!
		jmp	short print_loop	; ...next character
print_end:	retn				; return from function


;=============================================================================
; read a sector from disk

diskread:
		mov	cl, 3
loc_10:		push	cx
		mov	ax, ds:[data_5]
		mov	dx, word ptr ds:data_5+2
		div	word ptr ds:sechead	; ax,dxrem=dx:ax/data
		mov	ecx, eax
		xchg	ch, cl
		shl	cl, 6			; Shift w/zeros fill
		mov	eax, edx
		cwd				; Word to double word
		div	word ptr ds:[sectors]	; ax,dxrem=dx:ax/data
		mov	dh, al
		or	cl, dl
		inc	cl
		mov	dl, 80h			; drive, first hdd
		mov	eax, ds:[offset]	; eax = load offset
		xor	bx, bx			; bx = 0
		mov	bl, al
		and	bl, 0Fh
		shr	ax, 4			; ax = ax / 16
		mov	es, ax			; es = load offset
		mov	al, ds:[data_8e]
		mov	ah, 2			; function 'read sector'
		int	13h			; read it, disk=0x80

						;  read sectors to memory es:bx
						;   al=#,ch=cyl,cl=sectr,dh=head
		pop	cx
		jnc	loc_9			; Jump if carry=0
		cmp	ah, [di]
		adc	[bx+si], ax
		add	[bx+si], al
		jz	loc_9			; Jump if zero
		push	cx
		mov	ah, 0
		int	13h			; Disk  dl=drive 0  ah=func 00h
						;  reset disk, al=return status
		pop	cx
		dec	cl
		jne	loc_10

;==============================================================================

		;-[error messages]--------------
err0		db 'No active partition on HD',13,10,0
err1		db 'No HD params',13,10,0

		;-[some data]------------------	; offset 7DA4
offset		dd 2000h

data_5		db 1,0,0,0
data_7		db 0,0,0,0

		db 13h, 00h, 00h, 02h, 0Fh, 00h,1Eh, 00h, 02h, 00h, 8Dh,0BCh
		db 27h, 00h, 00h, 00h, 00h, 8Dh,84h, 20h, 00h, 00h, 00h, 00h
		db 8Dh,0BCh, 27h, 00h, 00h, 00h,00h, 8Dh, 84h, 20h, 00h, 00h
		db 00h, 00h, 8Dh,0BCh, 27h, 00h,00h, 00h, 00h, 8Dh, 84h, 20h
		db 00h, 00h, 00h, 00h, 8Dh,0BCh,27h, 00h, 00h, 00h, 00h, 8Dh
		db 84h, 20h, 00h, 00h, 00h, 00h,8Dh,0B6h, 00h, 00h, 00h, 00h
		db 8Dh,0BFh, 00h, 00h, 00h, 00h

		;-[boot mark]----------------------
		db	 55h,0AAh
;==============================================================================
boot		ends
		end
